/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.wrapper;

import org.springblade.community.entity.Agency;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.estate.entity.Feedback;
import org.springblade.estate.vo.FeedbackVO;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-05-18
 */
public class FeedbackWrapper extends BaseEntityWrapper<Feedback, FeedbackVO>  {

	private static IAgencyClient agencyClient;
	private static IResidentialClient residentialClient;

	public static FeedbackWrapper build() {
		return new FeedbackWrapper();
 	}

 	static {
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
		residentialClient = SpringUtil.getBean(IResidentialClient.class);
	}

	@Override
	public FeedbackVO entityVO(Feedback feedback) {
		FeedbackVO feedbackVO = Objects.requireNonNull(BeanUtil.copy(feedback, FeedbackVO.class));
		Agency agency = agencyClient.getById(feedback.getAgencyId());
		if(agency != null){
			feedbackVO.setAgencyName(agency.getName());
		}
		Residential residential = residentialClient.getById(feedback.getResidentialId());
		if(residential != null){
			feedbackVO.setResidentialName(residential.getName());
		}
		return feedbackVO;
	}

}
